#ifndef PERIPHERALS_H
#define PERIPHERALS_H

#include "nstdint.h"
#include "nstdbool.h"

void peripherals_init(void);	

void clock_config(void);

void gpio_init(void);

void delay_init(void);
void timer_disable(void);
void timer_enable(void);
void delay_us(unsigned int us);
void delay_ms(unsigned int ms);

void btns_init(void);

void PWMA_init(void);

void uart1_init(void);

#define DMA_M2M_IFCLR() DMA_M2M_STA = 0x00
#define DMA_M2M_TRIG() DMA_M2M_CR |= 0x40
#define DMA_M2M_DISABLE() DMA_M2M_CR &= ~0x80
#define DMA_M2M_ENABLE() DMA_M2M_CR |= 0x80 
void DMA_M2M(uint32_t src_addr,uint32_t aim_addr,uint16_t length);

#endif // !PERIPHERALS_H

