#include "main.h"
#include "peripherals.h"
#include "stdio.h"
#include "stdlib.h"

void btns1_handler(void *btn)
{
	// PWMB_CR1 &= ~0x01;
}

void btns5_handler(void *btn)
{

}

void btns9_handler(void *btn)
{

}


void btns17_handler(void *btn)
{

}

#define TMR0_VALUE()  ((uint16_t)TH0 << 8 | TL0)
#define TMR1_VALUE()  ((uint16_t)TH1 << 8 | TL1)
#define TMR2_VALUE()  ((uint16_t)T2H << 8 | T2L)
#define TMR3_VALUE()  ((uint16_t)T3H << 8 | T3L)
#define TMR4_VALUE()  ((uint16_t)T4H << 8 | T4L)
#define TMR11_VALUE()  ((uint16_t)T11H << 8 | T11L)

#define TMR0_RELOAD(time)  (TH0 = (uint16_t)(65536 - time) >> 8,TL0 = (uint16_t)(65536 - time) & 0xFF)
#define TMR1_RELOAD(time)  (TH1 = (uint16_t)(65536 - time) >> 8,TL1 = (uint16_t)(65536 - time) & 0xFF)
#define TMR2_RELOAD(time)  (T2H = (uint16_t)(65536 - time) >> 8,T2L = (uint16_t)(65536 - time) & 0xFF)
#define TMR3_RELOAD(time)  (T3H = (uint16_t)(65536 - time) >> 8,T3L = (uint16_t)(65536 - time) & 0xFF)
#define TMR3_SET(time)  	(T3H = (uint16_t)time >> 8,T3L = time)
#define TMR4_RELOAD(time)  (T4H = (uint16_t)(65536 - time) >> 8,T4L = (uint16_t)(65536 - time) & 0xFF)
#define TMR11_RELOAD(time)  (T11H = (uint16_t)(65536 - time) >> 8,T11L = (uint16_t)(65536 - time) & 0xFF)

void delayMicros(uint32_t micros) {
	T3R = 0;
	TMR3_RELOAD(micros);
	T3R = 1;
	while (!T3IF)
		;
	T3IF = 0;
}

void delayMillis(uint32_t millis) {
	T11CR &= 0x7F;
	TMR11_RELOAD(millis * 13);
	T11CR |= 0x80;
    T11CR &= 0xFE;
	while (!(T11CR & 0x01))
		;
}

void TMR3_Init(void) {
	//自动重装载模式
	TM3PS = 39;			//设置定时器时钟预分频 ( 注意:并非所有系列都有此寄存器,详情请查看数据手册 )
	T4T3M |= 0x02;			//定时器时钟1T模式
	TMR3_RELOAD(0);
	T4T3M |= 0x08;			//定时器3开始计时
}

void TMR11_Init(void) {
	//非自动重装载模式
	T11CR &= 0xf3;			//选择时钟源 (系统时钟SYSclk)
	T11PS = 0xFF;				//设置定时器时钟预分频 ( 注意:并非所有系列都有此寄存器,详情请查看数据手册 )
	T11CR &= 0xEF;			//定时器时钟12T模式
	TMR11_RELOAD(0);
	T11CR |= 0x80;			//定时器11开始计时
	T11CR &= 0xfd;			//禁止定时器中断
}

static uint8_t xdata dvp[186][70];
float xdata adc[2];

void main(void)
{
	uint16_t i,j;
	peripherals_init();
    TMR3_Init();
    TMR11_Init();
	// DMAIR = 0x3F;

	while(1)
	{
		for(i = 0; i < 186; i++)
		{
			for(j = 0; j < 70; j++)
			{
				srand(i + j);
				dvp[i][j] = rand() % 256;
				adc[0] = (float)rand() * RAND_MAX;
				if(adc[0] > adc[1])
					adc[1] = adc[0];
			}
		}
		T3R = 0;
		TMR3_SET(0);
		T3R = 1;
		T3IF = 0;
		for(i = 0; i < 186; i++)
			for(j = 0; j < 70; j++)
			{
				dvp[i][j] = dvp[i][j] > 175 ? 1 : 0;
			}
		if(T3IF)
			printf("overflow\n");
		printf("%u\n",TMR3_VALUE());
	}
}
